/************************************************************************************/
/*

Demo-Software for smart cameras from Vision Components
------------------------------------------------------

Program Description:
--------------------

This program switches the standard I/Os (STDIN, STDOUT, STDERR)
between ethernet and serial interfaces, and therefore allows to
use the shell from the serial interface.

Called without argument : switches to serial interface.
Called with an argument : switches to telnet.


Revision History:
-----------------

   Date           Version    Author  Changes
   Mar 23, 2007   1.0        MS      Initial Version

*/
/************************************************************************************/

#include <register.h>
#include <vcrt.h>
#include <sysvar.h>
/* Processor Default Stream indicators */
#define IO_PROC_STDIN  (3L)
#define IO_PROC_STDOUT (4L)
#define IO_PROC_STDERR (5L)

int main(int argc, char *argv)
{
  FILE *tty;
  unsigned dh=0,xbaud=9600;

  if(getvar(MODEL)<4000) return -1;


  print("TEST VC40xx kbd: serial shell\n");

  if(!argc)
  {
  
  if(getvar(MODEL) >= 4038) // ENCODER cams only
	INTERFACE_MODE(SERIAL);

 // print("defhandle=0x%08x devname='%s'\n",dh=getvar(DEFHANDLE),(char *)dh+8);
  if(dh)
  tty = (FILE *)dh;
  else  
  tty =io_fopen("kbd:", (char *)IO_SERIAL_TRANSLATION);	/* open serial device */
  
  if(!tty) return -1;
  
//  if(dh)
//	setvar(DEFHANDLE,(unsigned int)tty);

  print("baudrate=%d\n",xbaud);
  io_ioctl(tty,IO_IOCTL_SERIAL_SET_BAUD,&xbaud);

	print("switch stdin, stdout and stderr of shell to serial device !!!\n");
	io_set_handle(IO_STDIN ,tty);
	io_set_handle(IO_STDOUT,tty);
	io_set_handle(IO_STDERR,tty);
  }
  else
  {
	print("switch stdin, stdout and stderr of shell to telnet !!!\n");
	io_set_handle(IO_STDIN ,io_get_handle(IO_PROC_STDIN));
	io_set_handle(IO_STDOUT,io_get_handle(IO_PROC_STDOUT));
	io_set_handle(IO_STDERR,io_get_handle(IO_PROC_STDERR));
  }
}
